## libiio 0.6.40

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(libiio C)

set(LIBIIO_VERSION_MAJOR 0)
set(LIBIIO_VERSION_MINOR 6)
set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")

# Set the default install path to /usr
if (NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "default install path" FORCE)
endif()

set(INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin"
	CACHE PATH "Installation directory for binaries")
set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
	CACHE PATH "Installation directory for libraries")
set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include"
	CACHE PATH "Installation directory for headers")
set(INSTALL_PKGCONFIG_DIR "${INSTALL_LIB_DIR}/pkgconfig"
	CACHE PATH "Installation directory for pkgconfig (.pc) files")
set(INSTALL_DATA_DIR "${CMAKE_INSTALL_PREFIX}/share"
	CACHE PATH "Installation directory for data")

mark_as_advanced(INSTALL_BIN_DIR)
mark_as_advanced(INSTALL_LIB_DIR)
mark_as_advanced(INSTALL_INC_DIR)
mark_as_advanced(INSTALL_PKGCONFIG_DIR)
mark_as_advanced(INSTALL_DATA_DIR)

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
		"Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Release RelWithDebInfo MinSizeRel)
endif()

set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")

option(WITH_NETWORK_BACKEND "Enable the network backend" ON)

if (NOT MSVC)
	option(WITH_TESTS "Build the test programs" ON)
else()
	# Avoid annoying warnings from Visual Studio
	add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)
endif()

if (NOT WIN32)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	option(WITH_IIOD "Build the IIO Daemon" ON)
	option(WITH_LOCAL_BACKEND "Enable the local backend" ON)

	if (WITH_IIOD AND NOT WITH_LOCAL_BACKEND)
		message(SEND_ERROR "IIOD can only be enabled if the local backend is enabled")
	endif()
endif()

option(ENABLE_IPV6 "Define if you want to enable IPv6 support" ON)

include(CheckSymbolExists)
check_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)

if (ENABLE_IPV6)
	if (NOT HAVE_IPV6)
		message(WARNING "IPv6 is not available in your system.")
	else()
		add_definitions(-DHAVE_IPV6=1)
	endif()
endif()

set(LIBIIO_CFILES channel.c device.c context.c buffer.c utilities.c)
set(LIBIIO_HEADERS iio.h)

add_definitions(-D_POSIX_C_SOURCE=200809L -DLIBIIO_EXPORTS=1)

# Get the GIT hash of the latest commit
include(FindGit OPTIONAL)
if (GIT_FOUND)
	execute_process(
		COMMAND git rev-parse --show-toplevel
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE LIBIIO_GIT_REPO
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)

	if (${LIBIIO_GIT_REPO} MATCHES ${CMAKE_CURRENT_SOURCE_DIR})
		execute_process(
			COMMAND git rev-parse --short HEAD
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE LIBIIO_VERSION_GIT
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	endif()
endif()

if (NOT LIBIIO_VERSION_GIT)
	set(LIBIIO_VERSION_GIT v${VERSION})
endif()

add_definitions(-DLIBIIO_VERSION_MAJOR=${LIBIIO_VERSION_MAJOR})
add_definitions(-DLIBIIO_VERSION_MINOR=${LIBIIO_VERSION_MINOR})
add_definitions(-DLIBIIO_VERSION_GIT="${LIBIIO_VERSION_GIT}")

if(WITH_LOCAL_BACKEND)
	add_definitions(-DLOCAL_BACKEND=1)
	set(LIBIIO_CFILES ${LIBIIO_CFILES} local.c)
endif()

find_library(LIBUSB_LIBRARIES usb-1.0)
find_path(LIBUSB_INCLUDE_DIR libusb-1.0/libusb.h)
if (LIBUSB_LIBRARIES AND LIBUSB_INCLUDE_DIR)
	option(WITH_USB_BACKEND "Enable the libusb backend" ON)

	if(WITH_USB_BACKEND)
		add_definitions(-DUSB_BACKEND=1)
		set(LIBIIO_CFILES ${LIBIIO_CFILES} usb.c)
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBUSB_LIBRARIES})
		set(IIOD_CLIENT 1)
		set(NEED_LIBXML2 1)

		include_directories(${LIBUSB_INCLUDE_DIR})
	endif()
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

if(WITH_NETWORK_BACKEND)
	if (WIN32)
		set(LIBS_TO_LINK ${LIBS_TO_LINK} wsock32 ws2_32)
	endif()

	if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
		include(CheckCSourceCompiles)
		set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
		check_c_source_compiles("#include <fcntl.h>\nint main(void) { return O_TMPFILE; }" HAS_O_TMPFILE)

		if (HAS_O_TMPFILE)
			add_definitions(-D_GNU_SOURCE=1 -DWITH_NETWORK_GET_BUFFER=1)
		endif()
	endif()

	add_definitions(-DNETWORK_BACKEND=1)
	set(LIBIIO_CFILES ${LIBIIO_CFILES} network.c)

	find_library(AVAHI_CLIENT_LIBRARIES avahi-client)
	find_library(AVAHI_COMMON_LIBRARIES avahi-common)
	if(AVAHI_CLIENT_LIBRARIES AND AVAHI_COMMON_LIBRARIES)
		add_definitions(-DHAVE_AVAHI=1)
		set(AVAHI_LIBRARIES ${AVAHI_CLIENT_LIBRARIES} ${AVAHI_COMMON_LIBRARIES})
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${AVAHI_LIBRARIES})
	endif()

	set(NEED_THREADS 1)
	set(IIOD_CLIENT 1)
	set(NEED_LIBXML2 1)
endif()

if (NEED_LIBXML2)
	include(FindLibXml2)

	if (NOT LIBXML2_FOUND)
		message(SEND_ERROR "The selected backends require libxml2 to be installed")
	else()
		set(LIBIIO_CFILES ${LIBIIO_CFILES} xml.c)
		add_definitions(${LIBXML2_DEFINITIONS} -DXML_BACKEND=1)
		include_directories(${LIBXML2_INCLUDE_DIR})
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBXML2_LIBRARIES})
	endif()
endif()

if (NEED_THREADS)
	if (NOT WIN32)
		find_library(PTHREAD_LIBRARIES pthread)

		if (PTHREAD_LIBRARIES)
			set(LIBS_TO_LINK ${LIBS_TO_LINK} ${PTHREAD_LIBRARIES})
			set(LIBIIO_CFILES ${LIBIIO_CFILES} lock.c)
		else()
			message(SEND_ERROR "The pthread library is a requirement for the selected backends")
		endif()
	else()
		set(LIBIIO_CFILES ${LIBIIO_CFILES} lock.c)
	endif()
endif()

if (IIOD_CLIENT)
	set(LIBIIO_CFILES ${LIBIIO_CFILES} iiod-client.c)
endif()

configure_file(libiio.iss.cmakein ${CMAKE_CURRENT_BINARY_DIR}/libiio.iss @ONLY)

set(LIBIIO_PC ${CMAKE_CURRENT_BINARY_DIR}/libiio.pc)
configure_file(libiio.pc.cmakein ${LIBIIO_PC} @ONLY)
install(FILES ${LIBIIO_PC} DESTINATION "${INSTALL_PKGCONFIG_DIR}")

#set(SETUP_PY ${CMAKE_CURRENT_SOURCE_DIR}/bindings/python/setup.py)
#configure_file(python/setup.py.in ${SETUP_PY} @ONLY)

add_library(iio ${LIBIIO_CFILES} ${LIBIIO_HEADERS})
set_target_properties(iio PROPERTIES VERSION ${VERSION} SOVERSION ${LIBIIO_VERSION_MAJOR} FRAMEWORK TRUE PUBLIC_HEADER ${LIBIIO_HEADERS})
target_link_libraries(iio LINK_PRIVATE ${LIBS_TO_LINK})

if (MSVC)
	set_target_properties(iio PROPERTIES OUTPUT_NAME libiio)
endif()

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS iio
		ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
		LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
		RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
		FRAMEWORK DESTINATION "${INSTALL_LIB_DIR}"
		PUBLIC_HEADER DESTINATION "${INSTALL_INC_DIR}")
endif()

find_package(Doxygen)
if(DOXYGEN_FOUND)
	option(WITH_DOC "Generate documentation with Doxygen" ON)

	if (WITH_DOC)
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
		set(HTML_DEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/html)
		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/doc DESTINATION ${HTML_DEST_DIR})

		add_custom_command(TARGET iio POST_BUILD
			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMENT "Generating API documentation with Doxygen" VERBATIM
			)

		install(DIRECTORY ${HTML_DEST_DIR}
			DESTINATION ${INSTALL_DATA_DIR}/doc/libiio${LIBIIO_VERSION_MAJOR}-doc)
	endif()
else()
	message(STATUS "Doxygen not found, API documentation won't be generated")
endif()

# Create an installer if compiling for OSX
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	set(LIBIIO_PKG ${CMAKE_CURRENT_BINARY_DIR}/libiio-${VERSION}.pkg)
	set(LIBIIO_TEMP_PKG ${CMAKE_CURRENT_BINARY_DIR}/libiio-${VERSION}-temp.pkg)
	set(LIBIIO_DISTRIBUTION_XML ${CMAKE_CURRENT_BINARY_DIR}/Distribution.xml)
	configure_file(Distribution.xml.cmakein ${LIBIIO_DISTRIBUTION_XML} @ONLY)

	find_program(PKGBUILD_EXECUTABLE
		NAMES pkgbuild
		DOC "OSX Package builder (pkgbuild)")
	mark_as_advanced(PKGBUILD_EXECUTABLE)

	find_program(PRODUCTBUILD_EXECUTABLE
		NAMES productbuild
		DOC "OSX Package builder (productbuild)")
	mark_as_advanced(PRODUCTBUILD_EXECUTABLE)

	add_custom_command(OUTPUT ${LIBIIO_TEMP_PKG} COMMAND ${PKGBUILD_EXECUTABLE}
			--root ${CMAKE_CURRENT_BINARY_DIR}/Debug
			--identifier libiio --version ${VERSION}
			--install-location /System/Library/Frameworks ${LIBIIO_TEMP_PKG}
		DEPENDS iio
	)

	add_custom_command(OUTPUT ${LIBIIO_PKG} COMMAND ${PRODUCTBUILD_EXECUTABLE}
			--distribution ${LIBIIO_DISTRIBUTION_XML} ${LIBIIO_PKG}
		DEPENDS ${LIBIIO_DISTRIBUTION_XML} ${LIBIIO_TEMP_PKG}
	)

	if (PKGBUILD_EXECUTABLE AND PRODUCTBUILD_EXECUTABLE)
		add_custom_target(libiio-pkg ALL DEPENDS ${LIBIIO_PKG})
	else()
		message(WARNING "Missing pkgbuild or productbuild: OSX installer won't be created.")
	endif()
endif()

if(WITH_IIOD)
	add_subdirectory(iiod)
endif()

if(WITH_TESTS)
	add_subdirectory(tests)
endif()

add_subdirectory(bindings)

=== bindings/CMakeLists.txt ===
add_subdirectory(csharp)
add_subdirectory(python)

=== examples/Makefile ===
# libiio - Library for interfacing industrial I/O (IIO) devices
#
# Copyright (C) 2014 Analog Devices, Inc.
# Author: Paul Cercueil <paul.cercueil@analog.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.


TARGETS := ad9361-iiostream iio-monitor

CFLAGS = -Wall

.PHONY: all clean

all: $(TARGETS)

iio-monitor: iio-monitor.o
	$(CC) -o $@ $^ $(LDFLAGS) -lpthread -lncurses -lcdk -liio

ad9361-iiostream : ad9361-iiostream.o
	$(CC) -o $@ $^ $(LDFLAGS) -liio

clean:
	rm -f $(TARGETS) $(TARGETS:%=%.o)

=== iiod/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(iiod C)

include(FindBISON)
include(FindFLEX)

flex_target(lexer
	${CMAKE_CURRENT_SOURCE_DIR}/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.c)
bison_target(parser
	${CMAKE_CURRENT_SOURCE_DIR}/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.c)
add_flex_bison_dependency(lexer parser)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(IIOD_CFILES iiod.c ops.c ${BISON_parser_OUTPUTS} ${FLEX_lexer_OUTPUTS})

add_executable(iiod ${IIOD_CFILES})
target_link_libraries(iiod iio ${PTHREAD_LIBRARIES} ${AVAHI_LIBRARIES})

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS iiod RUNTIME DESTINATION sbin)
endif()

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(iio_genxml  C)
project(iio_info    C)
project(iio_readdev C)
project(iio_reg     C)

add_executable(iio_genxml  iio_genxml.c)
add_executable(iio_info    iio_info.c)
add_executable(iio_readdev iio_readdev.c)
add_executable(iio_reg     iio_reg.c)

target_link_libraries(iio_genxml  iio)
target_link_libraries(iio_info    iio)
target_link_libraries(iio_readdev iio)
target_link_libraries(iio_reg     iio)

if(PTHREAD_LIBRARIES)
	project(iio_adi_xflow_check C)
	add_executable(iio_adi_xflow_check iio_adi_xflow_check.c)
	target_link_libraries(iio_adi_xflow_check iio pthread)
endif()

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS iio_genxml  RUNTIME DESTINATION bin)
	install(TARGETS iio_info    RUNTIME DESTINATION bin)
	install(TARGETS iio_readdev RUNTIME DESTINATION bin)
	if(PTHREAD_LIBRARIES)
		install(TARGETS iio_adi_xflow_check RUNTIME DESTINATION bin)
	endif()
	install(TARGETS iio_reg     RUNTIME DESTINATION bin)
endif()

=== bindings/csharp/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(libiio-sharp NONE)

find_program(MCS_EXECUTABLE
	NAMES mcs csc
	PATHS ENV MCS_EXECUTABLE_PATH
	DOC "C# compiler")
mark_as_advanced(MCS_EXECUTABLE)

if (MCS_EXECUTABLE)
	option(CSHARP_BINDINGS "Install C# bindings" ON)

	if (CSHARP_BINDINGS)
		set(LIBIIO_CS_PC_IN "${CMAKE_CURRENT_SOURCE_DIR}/libiio-sharp.pc.cmakein")
		set(LIBIIO_CS_PC "${CMAKE_CURRENT_BINARY_DIR}/libiio-sharp-${VERSION}.pc")
		configure_file(${LIBIIO_CS_PC_IN} ${LIBIIO_CS_PC} @ONLY)
		install(FILES ${LIBIIO_CS_PC} DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig")

		set(LIBIIO_CS_DLL_CONFIG_IN "${CMAKE_CURRENT_SOURCE_DIR}/libiio-sharp.dll.config.cmakein")
		set(LIBIIO_CS_DLL_CONFIG "${CMAKE_CURRENT_BINARY_DIR}/libiio-sharp.dll.config")
		configure_file(${LIBIIO_CS_DLL_CONFIG_IN} ${LIBIIO_CS_DLL_CONFIG} @ONLY)
		install(FILES ${LIBIIO_CS_DLL_CONFIG} DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/cli/libiio-sharp-${VERSION})

		set(LIBIIO_CS_VERSION ${VERSION}.0.0)
		set(LIBIIO_CS_INFO_IN ${CMAKE_CURRENT_SOURCE_DIR}/AssemblyInfo.cs.in)
		set(LIBIIO_CS_INFO ${CMAKE_CURRENT_BINARY_DIR}/AssemblyInfo.cs)
		configure_file(${LIBIIO_CS_INFO_IN} ${LIBIIO_CS_INFO} @ONLY)

		set(LIBIIO_CS_DLL "${CMAKE_CURRENT_BINARY_DIR}/libiio-sharp.dll")
		set(LIBIIO_CS_SOURCES
			${CMAKE_CURRENT_SOURCE_DIR}/Attr.cs
			${CMAKE_CURRENT_SOURCE_DIR}/Channel.cs
			${CMAKE_CURRENT_SOURCE_DIR}/Context.cs
			${CMAKE_CURRENT_SOURCE_DIR}/Device.cs
			${CMAKE_CURRENT_SOURCE_DIR}/IOBuffer.cs
			${CMAKE_CURRENT_SOURCE_DIR}/Trigger.cs
			${LIBIIO_CS_INFO}
			)

		foreach(SRC ${LIBIIO_CS_SOURCES})
			file(TO_NATIVE_PATH ${SRC} TMP)
			set(LIBIIO_CS_SOURCES_REALPATH ${LIBIIO_CS_SOURCES_REALPATH} ${TMP})
		endforeach(SRC)

		file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/key.snk SIGN_KEY)
		file(TO_NATIVE_PATH ${LIBIIO_CS_DLL} LIBIIO_CS_DLL_OUT)

		add_custom_command(OUTPUT ${LIBIIO_CS_DLL}
			COMMAND ${MCS_EXECUTABLE} /target:library /out:${LIBIIO_CS_DLL_OUT} /debug /keyfile:${SIGN_KEY} ${LIBIIO_CS_SOURCES_REALPATH}
			DEPENDS ${LIBIIO_CS_SOURCES}
			)

		add_custom_target(libiio-sharp ALL DEPENDS ${LIBIIO_CS_DLL})

		install(FILES ${LIBIIO_CS_DLL} ${LIBIIO_CS_DLL}.mdb DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/cli/libiio-sharp-${VERSION})
	endif()
endif()

=== debian/changelog ===
libiio (0.6.40-1) unstable; urgency=medium

  * Initial upload to Debian (closes: #814032)
  * Sponsor libiio for Paul Cercueil
  * Update to v0.6-40-g93b5950
  * repackage as 3.0 (quilt)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 07 Feb 2016 15:10:46 -0500

libiio (0.6) unstable; urgency=low
  * Improved parsing of sysfs files
  * Added iio_reg test program
  * Revert to regular I/O in the network backend if zerocopy is not available
  * Fix bugs reported by Valgrind
  * IIOD can now run interactively from the terminal
  * Improved I/O handling in IIOD
  * New API functions

 -- Paul Cercueil <paul.cercueil@analog.com>  Tue, 4 Dec 2015 12:58:52 +0200

libiio (0.5) unstable; urgency=low

  * Fix locales support on Windows and MinGW
  * Add iio_adi_xflow_check tool
  * Boost client->server transfers using delayed error reporting
  * Enable support for zero-copy transfers in the network backend
  * Created packages for the Python and C# bindings
  * Lots of improvements on the Python and C# bindings
  * Enhanced error reporting

 -- Paul Cercueil <paul.cercueil@analog.com>  Tue, 24 Mar 2015 13:19:22 +0200

libiio (0.4) unstable; urgency=low

  * Boost communication speed of the network backend
  * Fix socket I/O timeout on UNIX systems
  * New API function: iio_context_get_description

 -- Paul Cercueil <paul.cercueil@analog.com>  Fri, 6 Feb 2015 11:42:01 +0200

libiio (0.3) unstable; urgency=low

  * Improved error handling
  * IPv6 support in both libiio and iiod
  * Enhanced CMake build scripts (now builds under MinGW and Windows)
  * Old Makefile-based build system has been dropped
  * Scripts to create Debian packages

 -- Paul Cercueil <paul.cercueil@analog.com>  Fri, 12 Dec 2014 17:14:59 +0200

libiio (0.2) unstable; urgency=low

  * Initial release.

 -- Paul Cercueil <paul.cercueil@analog.com>  Fri, 28 Nov 2014 14:51:18 +0200

=== debian/control ===
Source: libiio
Section: libs
Priority: optional
Maintainer: Paul Cercueil <paul.cercueil@analog.com>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: bison,
               cli-common-dev (>= 0.9~),
               cmake (>= 2.8),
               debhelper (>= 9),
               dh-python,
               doxygen,
               flex,
               libxml2-dev,
               python
Standards-Version: 3.9.6
Homepage: https://github.com/analogdevicesinc/libiio
Vcs-Git: https://github.com/analogdevicesinc/libiio.git

Package: libiio0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: avahi-daemon
Description: Library for interfacing with IIO devices
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the shared library.

Package: libiio-dev
Section: libdevel
Architecture: any
Depends: libiio0 (= ${binary:Version}), ${misc:Depends}
Description: libiio development files
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the development files.

Package: iiod
Architecture: any
Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: avahi-daemon
Description: Daemon to share IIO devices on the network
 IIOD is a network daemon that communicates with the network backend of libiio.
 It can be used, for instance, to stream the flow of data samples from one weak
 system to a more powerful one, where the samples will be processed.

Package: libiio-utils
Architecture: any
Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Miscellaneous libiio utilities
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains several basic utilities for testing libiio.

Package: python-libiio
Section: python
Architecture: all
Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${python:Depends}
Description: Python bindings for libiio
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the Python bindings for libiio.

Package: libiio0-cil
Section: cli-mono
Architecture: all
Depends: libiio0 (>= ${binary:Version}), ${cli:Depends}, ${misc:Depends}
Description: CLI bindings for libiio
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the CLI bindings for libiio.

Package: libiio-cil-dev
Section: cli-mono
Architecture: all
Depends: libiio0-cil (= ${binary:Version}), ${misc:Depends}
Description: CLI bindings for libiio (development)
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains development files for the CLI bindings of libiio,
 and should be used for compilation.

Package: libiio0-doc
Section: doc
Architecture: all
Depends: libjs-jquery, ${misc:Depends}
Description: libiio documentation
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel --with=cli,python2

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_compress:
	dh_compress -X.c -X.C

override_dh_clistrip:
	dh_clistrip --exclude=mdb

override_dh_auto_install:
	dh_auto_install
	# jquery.js is provided in another debian package, do not ship one here too
	- rm debian/tmp/usr/share/doc/libiio0-doc/html/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js debian/tmp/usr/share/doc/libiio0-doc/html/jquery.js

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/v$1.tar.gz/ \
  https://github.com/analogdevicesinc/libiio/tags .*/v(\d\S*)\.tar\.gz

## libiio 0.6.187

=== debian/changelog ===
libiio (0.6.187-1) unstable; urgency=medium

  * update to v0.6-187-g5d107e9
  * put iiod in Section: net (Closes: #814703)
  * libiio0-cil arch any (not all) (Closes: #816981)

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 28 Apr 2016 00:48:43 -0400

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                flex,
                libxml2-dev,
                python
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/analogdevicesinc/libiio
 Vcs-Git: https://github.com/analogdevicesinc/libiio.git
 
@@ -43,6 +43,7 @@
 Package: iiod
 Architecture: any
 Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Section: net
 Suggests: avahi-daemon
 Description: Daemon to share IIO devices on the network
  IIOD is a network daemon that communicates with the network backend of libiio.
@@ -72,7 +73,7 @@
 
 Package: libiio0-cil
 Section: cli-mono
-Architecture: all
+Architecture: any
 Depends: libiio0 (>= ${binary:Version}), ${cli:Depends}, ${misc:Depends}
 Description: CLI bindings for libiio
  Libiio is a library that has been conceived to ease the development of

## libiio 0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(libiio C)
 
 set(LIBIIO_VERSION_MAJOR 0)
-set(LIBIIO_VERSION_MINOR 6)
+set(LIBIIO_VERSION_MINOR 7)
 set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")
 
 # Set the default install path to /usr
@@ -10,22 +10,13 @@
 	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "default install path" FORCE)
 endif()
 
-set(INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin"
-	CACHE PATH "Installation directory for binaries")
-set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
-	CACHE PATH "Installation directory for libraries")
-set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include"
-	CACHE PATH "Installation directory for headers")
-set(INSTALL_PKGCONFIG_DIR "${INSTALL_LIB_DIR}/pkgconfig"
+set(CMAKE_INSTALL_DOCDIR "" CACHE PATH "documentation root (DATAROOTDIR/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc)")
+include(GNUInstallDirs)
+set(CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc")
+
+set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
 	CACHE PATH "Installation directory for pkgconfig (.pc) files")
-set(INSTALL_DATA_DIR "${CMAKE_INSTALL_PREFIX}/share"
-	CACHE PATH "Installation directory for data")
-
-mark_as_advanced(INSTALL_BIN_DIR)
-mark_as_advanced(INSTALL_LIB_DIR)
-mark_as_advanced(INSTALL_INC_DIR)
 mark_as_advanced(INSTALL_PKGCONFIG_DIR)
-mark_as_advanced(INSTALL_DATA_DIR)
 
 if (NOT CMAKE_BUILD_TYPE)
 	set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
@@ -37,16 +28,25 @@
 set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")
 
 option(WITH_NETWORK_BACKEND "Enable the network backend" ON)
-
-if (NOT MSVC)
-	option(WITH_TESTS "Build the test programs" ON)
-else()
+option(WITH_TESTS "Build the test programs" ON)
+
+if (MSVC)
 	# Avoid annoying warnings from Visual Studio
 	add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)
 endif()
 
 if (NOT WIN32)
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
+endif()
+
+if (CMAKE_COMPILER_IS_GNUCC)
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-sign-compare")
+
+	include(CheckCCompilerFlag)
+	check_c_compiler_flag(-Wpedantic HAS_WPEDANTIC)
+	if (HAS_WPEDANTIC)
+		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpedantic")
+	endif()
 endif()
 
 IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
@@ -56,6 +56,12 @@
 	if (WITH_IIOD AND NOT WITH_LOCAL_BACKEND)
 		message(SEND_ERROR "IIOD can only be enabled if the local backend is enabled")
 	endif()
+	if (WITH_IIOD)
+		set(NEED_THREADS 1)
+	endif()
+
+	set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
+	add_definitions(-D_GNU_SOURCE=1)
 endif()
 
 option(ENABLE_IPV6 "Define if you want to enable IPv6 support" ON)
@@ -71,16 +77,16 @@
 	endif()
 endif()
 
-set(LIBIIO_CFILES channel.c device.c context.c buffer.c utilities.c)
+set(LIBIIO_CFILES channel.c device.c context.c buffer.c utilities.c scan.c)
 set(LIBIIO_HEADERS iio.h)
 
-add_definitions(-D_POSIX_C_SOURCE=200809L -DLIBIIO_EXPORTS=1)
+add_definitions(-D_POSIX_C_SOURCE=200809L -D__XSI_VISIBLE=500 -DLIBIIO_EXPORTS=1)
 
 # Get the GIT hash of the latest commit
 include(FindGit OPTIONAL)
 if (GIT_FOUND)
 	execute_process(
-		COMMAND git rev-parse --show-toplevel
+		COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
 		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
 		OUTPUT_VARIABLE LIBIIO_GIT_REPO
 		OUTPUT_STRIP_TRAILING_WHITESPACE
@@ -88,7 +94,7 @@
 
 	if (${LIBIIO_GIT_REPO} MATCHES ${CMAKE_CURRENT_SOURCE_DIR})
 		execute_process(
-			COMMAND git rev-parse --short HEAD
+			COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
 			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
 			OUTPUT_VARIABLE LIBIIO_VERSION_GIT
 			OUTPUT_STRIP_TRAILING_WHITESPACE
@@ -120,8 +126,27 @@
 		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBUSB_LIBRARIES})
 		set(IIOD_CLIENT 1)
 		set(NEED_LIBXML2 1)
+		set(NEED_THREADS 1)
 
 		include_directories(${LIBUSB_INCLUDE_DIR})
+	endif()
+endif()
+
+find_library(LIBSERIALPORT_LIBRARIES serialport)
+find_path(LIBSERIALPORT_INCLUDE_DIR libserialport.h)
+if (LIBSERIALPORT_LIBRARIES AND LIBSERIALPORT_INCLUDE_DIR)
+	option(WITH_SERIAL_BACKEND "Enable the serial backend" ON)
+
+	if (WITH_SERIAL_BACKEND)
+		add_definitions(-DSERIAL_BACKEND=1)
+		set(LIBIIO_CFILES ${LIBIIO_CFILES} serial.c)
+		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBSERIALPORT_LIBRARIES})
+
+		set(NEED_THREADS 1)
+		set(IIOD_CLIENT 1)
+		set(NEED_LIBXML2 1)
+
+		include_directories(${LIBSERIALPORT_INCLUDE_DIR})
 	endif()
 endif()
 
@@ -134,12 +159,30 @@
 
 	if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 		include(CheckCSourceCompiles)
-		set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
 		check_c_source_compiles("#include <fcntl.h>\nint main(void) { return O_TMPFILE; }" HAS_O_TMPFILE)
 
 		if (HAS_O_TMPFILE)
-			add_definitions(-D_GNU_SOURCE=1 -DWITH_NETWORK_GET_BUFFER=1)
-		endif()
+			option(WITH_NETWORK_GET_BUFFER "Enable experimental zero-copy transfers" OFF)
+
+			if (WITH_NETWORK_GET_BUFFER)
+				add_definitions(-DWITH_NETWORK_GET_BUFFER=1)
+			endif(WITH_NETWORK_GET_BUFFER)
+		endif(HAS_O_TMPFILE)
+
+		check_c_source_compiles("#include <sys/eventfd.h>\nint main(void) { return eventfd(0, EFD_CLOEXEC | EFD_NONBLOCK); }" HAS_EVENTFD)
+
+		if (HAS_EVENTFD)
+			add_definitions(-DWITH_NETWORK_EVENTFD=1)
+		endif(HAS_EVENTFD)
+	endif()
+
+	if(NOT WIN32)
+		include(CheckCSourceCompiles)
+		check_c_source_compiles("#include <unistd.h>\n#include <fcntl.h>\nint main(void) { int fd[2]; return pipe2(fd, O_CLOEXEC | O_NONBLOCK); }" HAS_PIPE2)
+
+		if (HAS_PIPE2)
+			add_definitions(-DHAS_PIPE2=1)
+		endif(HAS_PIPE2)
 	endif()
 
 	add_definitions(-DNETWORK_BACKEND=1)
@@ -158,12 +201,23 @@
 	set(NEED_LIBXML2 1)
 endif()
 
-if (NEED_LIBXML2)
+# Since libxml2-2.9.2, libxml2 provides its own LibXml2-config.cmake, with all
+# variables correctly set.
+# So, try first to find the CMake module provided by libxml2 package, then fallback
+# on the CMake's FindLibXml2.cmake module (which can lack some definition, especially
+# in static build case).
+find_package(LibXml2 QUIET NO_MODULE)
+if(DEFINED LIBXML2_VERSION_STRING)
+	set(LIBXML2_FOUND ON)
+	set(LIBXML2_INCLUDE_DIR ${LIBXML2_INCLUDE_DIRS})
+else()
 	include(FindLibXml2)
-
-	if (NOT LIBXML2_FOUND)
-		message(SEND_ERROR "The selected backends require libxml2 to be installed")
-	else()
+endif()
+
+if (LIBXML2_FOUND)
+	option(WITH_XML_BACKEND "Enable the serial backend" ON)
+
+	if (WITH_XML_BACKEND)
 		set(LIBIIO_CFILES ${LIBIIO_CFILES} xml.c)
 		add_definitions(${LIBXML2_DEFINITIONS} -DXML_BACKEND=1)
 		include_directories(${LIBXML2_INCLUDE_DIR})
@@ -171,19 +225,24 @@
 	endif()
 endif()
 
+if (NEED_LIBXML2 AND NOT (LIBXML2_FOUND AND WITH_XML_BACKEND))
+	message(SEND_ERROR "The selected backends require libxml2 and the XML backend to be enabled")
+endif()
+
 if (NEED_THREADS)
 	if (NOT WIN32)
 		find_library(PTHREAD_LIBRARIES pthread)
 
 		if (PTHREAD_LIBRARIES)
 			set(LIBS_TO_LINK ${LIBS_TO_LINK} ${PTHREAD_LIBRARIES})
-			set(LIBIIO_CFILES ${LIBIIO_CFILES} lock.c)
 		else()
-			message(SEND_ERROR "The pthread library is a requirement for the selected backends")
+			message(WARNING "pthread library not found; support for threads will be disabled")
+			add_definitions(-DNO_THREADS=1)
 		endif()
 	else()
-		set(LIBIIO_CFILES ${LIBIIO_CFILES} lock.c)
-	endif()
+	endif()
+
+	set(LIBIIO_CFILES ${LIBIIO_CFILES} lock.c)
 endif()
 
 if (IIOD_CLIENT)
@@ -200,7 +259,15 @@
 #configure_file(python/setup.py.in ${SETUP_PY} @ONLY)
 
 add_library(iio ${LIBIIO_CFILES} ${LIBIIO_HEADERS})
-set_target_properties(iio PROPERTIES VERSION ${VERSION} SOVERSION ${LIBIIO_VERSION_MAJOR} FRAMEWORK TRUE PUBLIC_HEADER ${LIBIIO_HEADERS})
+set_target_properties(iio PROPERTIES
+	VERSION ${VERSION}
+	SOVERSION ${LIBIIO_VERSION_MAJOR}
+	FRAMEWORK TRUE
+	PUBLIC_HEADER ${LIBIIO_HEADERS}
+	C_STANDARD 99
+	C_STANDARD_REQUIRED ON
+	C_EXTENSIONS OFF
+)
 target_link_libraries(iio LINK_PRIVATE ${LIBS_TO_LINK})
 
 if (MSVC)
@@ -209,11 +276,11 @@
 
 if(NOT SKIP_INSTALL_ALL)
 	install(TARGETS iio
-		ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
-		LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
-		RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
-		FRAMEWORK DESTINATION "${INSTALL_LIB_DIR}"
-		PUBLIC_HEADER DESTINATION "${INSTALL_INC_DIR}")
+		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+		FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
+		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 endif()
 
 find_package(Doxygen)
@@ -231,8 +298,7 @@
 			COMMENT "Generating API documentation with Doxygen" VERBATIM
 			)
 
-		install(DIRECTORY ${HTML_DEST_DIR}
-			DESTINATION ${INSTALL_DATA_DIR}/doc/libiio${LIBIIO_VERSION_MAJOR}-doc)
+		install(DIRECTORY ${HTML_DEST_DIR} DESTINATION ${CMAKE_INSTALL_DOCDIR})
 	endif()
 else()
 	message(STATUS "Doxygen not found, API documentation won't be generated")

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(iio_genxml  C)
project(iio_info    C)
project(iio_readdev C)
project(iio_reg     C)

if (MSVC)
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src)
	set(GETOPT_C_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src/getopt.c)
endif (MSVC)

add_executable(iio_genxml  iio_genxml.c   ${GETOPT_C_FILE})
add_executable(iio_info    iio_info.c     ${GETOPT_C_FILE})
add_executable(iio_readdev iio_readdev.c  ${GETOPT_C_FILE})
add_executable(iio_reg     iio_reg.c      ${GETOPT_C_FILE})

target_link_libraries(iio_genxml  iio)
target_link_libraries(iio_info    iio)
target_link_libraries(iio_readdev iio ${PTHREAD_LIBRARIES})
target_link_libraries(iio_reg     iio)

set(IIO_TESTS_TARGETS iio_genxml iio_info iio_readdev iio_reg)

if(PTHREAD_LIBRARIES)
	project(iio_adi_xflow_check C)
	add_executable(iio_adi_xflow_check iio_adi_xflow_check.c)
	target_link_libraries(iio_adi_xflow_check iio ${PTHREAD_LIBRARIES})
	set(IIO_TESTS_TARGETS ${IIO_TESTS_TARGETS} iio_adi_xflow_check)
endif()

set_target_properties(${IIO_TESTS_TARGETS} PROPERTIES
	C_STANDARD 99
	C_STANDARD_REQUIRED ON
	C_EXTENSIONS OFF
)

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS ${IIO_TESTS_TARGETS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== debian/changelog ===
libiio (0.7-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 10 Jul 2016 11:34:33 -0400

=== debian/control ===
--- 
+++ 
@@ -85,7 +85,7 @@
 Package: libiio-cil-dev
 Section: cli-mono
 Architecture: all
-Depends: libiio0-cil (= ${binary:Version}), ${misc:Depends}
+Depends: libiio0-cil (>= ${source:Version}), ${misc:Depends}
 Description: CLI bindings for libiio (development)
  Libiio is a library that has been conceived to ease the development of
  applications interfacing Industrial Input/Output (IIO) devices through
